package com.example.dieroll_countdowntimer_kotlin

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.widget.Toast
import android.os.CountDownTimer
import android.widget.Button
import android.widget.ImageView
import java.util.*


class MainActivity : AppCompatActivity() {

    var myDie: Int = 0 //class-level variable to hold final value

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        //random number generator
        val myRandom = Random()
        //connect layout to code button and imageview
        val btnRoll = findViewById<Button>(R.id.btnRoll)
        val ivDie = findViewById<ImageView>(R.id.ivDie)

        //**********************************************************************************************
        // when button is clicked start "count down" timer
        btnRoll.setOnClickListener{

            //disable button so only one timer gets going at a time
            btnRoll.isEnabled = false

            //********************************************************************************
            // instantiate count down timer
            // first parameter: how long it will last overall
            // second parameter: interval between "tick" repeated events
            val myTimer = object : CountDownTimer(2000, 100) {
                internal var die: Int = 0
                //repeating event -- get new random number & display corresponding image
                override fun onTick(l: Long) {
                    die = myRandom.nextInt(6) + 1
                    val id = resources.getIdentifier("die$die", "drawable", packageName)
                    ivDie.setImageResource(id)
                }//end onTick

                // ending event -- set class-level variable to "last" random number
                override fun onFinish() {
                    myDie = die
                    Toast.makeText(applicationContext, "final: $myDie", Toast.LENGTH_SHORT).show()
                    btnRoll.isEnabled=true  //re-enable button
                }//end onFinish
            } //end CountDownTimer
            // you need to start the timer or nothing happens
            myTimer.start()

        }//end setOnClickListener

    }//end onCreate
}//end MainActivity
